/*	Kszts egy 13 bites lptetregisztert. A P1.5 bemenet legyen a
      	regiszter adatbemenete, a P1.6 bemeneten megjelen felfut l
      	lptesse a regisztert. A regiszter pillanatnyi llapota (13 bit)
      	a P0.0-P0.7, P1.0-P1.4 kimeneteken legyen lthat.
*/

#include "hw.h"

#if defined __SDCC || defined SDCC
#define BE_ADAT P1_5
#define BE_CLK  P1_6
#elif defined __C51__
sbit BE_ADAT= P1^5;
sbit BE_CLK= P1^6;
#else /* IAR4 */
#define BE_ADAT (P1.5)
#define BE_CLK  (P1.6)
#endif

int regiszter; /* 16 bit eleg a 13 tarolasara */
int x;

bit elozo, dummy;

void main(void)
{
  /* kezdoertekek */
  elozo= BE_CLK;
  regiszter= 0;
  P0= 0;
  P1= 0xe0;
  /* vegtelen ciklus */
  while (1)
    {
      if (BE_CLK!=elozo)
	{
	  /* valtozott */
	  elozo= BE_CLK;
	  if (BE_CLK)
	    {
	      /* 0-rol 1-re: felfuto el */
	      /* leptetes balra 1-el, vagy: regiszter*=2 */
	      regiszter= (regiszter<<1)&0x1fff;
	      /* adatbemenet bemasolasa a regiszter jobb oldalara */
	      if (BE_ADAT)
		regiszter|= 1;
	      /* eredmeny a kimenetre */
	      /* also 8 bit */
	      P0= regiszter & 0xff;
	      /* felso 5 bit */
	      x= regiszter >> 8;	/* az int valtozo felso fele */
	      x= x | 0xffe0;		/* nem hasznalt bitek 1-be allitasa */
	      P1= x & 0xff;
	    }
	}
    }
}
