/* Soros vonal kezelest bemutato demo. */

#include "hw.h"

/* A segedlet fuggvenyei */
#include "serial.h"
#include "print.h"

#if defined SDCC || defined __SDCC
#define BE  P1_0
#define KI  P1_1
#define OUT P1_2
#elif defined __C51__
sbit BE= P1^0;
sbit KI= P1^1;
sbit OUT=P1^2;
#else
#define BE  P1.0
#define KI  P1.1
#define OUT P1.2
#endif

/* Beolvaso fuggveny, egy sort olvas be (ENTER lenyomasaig).
   Parameterul egy kello meretu tomb adando meg, amelyet feltolt
   a soros vonalrol beolvasott karakterekkel (az ENTER-t is beleertve).
*/
void gets(char *s)
{
  do
    {
      /* A vett karaktert visszakuldi a soros vonalra (echo),
	 igy a felhasznalo latja amit begepel */
      kikuld(*s= vett());
      s++;
    }
  /* Nemely terminal az ENTER lenyomasara mast es mast kuldhet */
  while (*(s-1)!='\n' && *(s-1)!='\r');
  /* A "szoveg" tombok 0-ra kell vegzodjenek */
  *s= '\0';
}

bit elozo;	/* Bemenet valtozas figyeleshez */
bit dummy;	/* Az IAR4 fordito hibaja miatt... */

/* A bemenet megvaltozasat kezelo fuggveny: felfuto el
   eseten valtoztatja a P1.1 kimenetet */
void proc_bemenet()
{
  elozo= BE;
  if (BE)
    KI= !KI;
}

/* Soros vonalon beerkezett karakter kezeleset vegzo fuggveny */
void proc_soros()
{
  /* A beerkezett karakter beolvasasa */
  char c= vett();
  /* "echo", hogy latszodjon a gepeles */
  kikuld(c);
  /* Feldolgozas */
  switch (c)
    {
    case '0':
      /* Bemenet valtozas szimulalasa.
	 Figyelem: normal korulmenyek kozott ILLEGALIS! */
      BE= 0;
      break;
    case '1':
      /* Bemenet valtozas szimulalasa.
	 Figyelem: normal korulmenyek kozott ILLEGALIS! */
      BE= 1;
      break;
    case '2':
      /* Bemenet valtozas szimulalasa.
	 Figyelem: normal korulmenyek kozott ILLEGALIS! */
      BE= !BE;
      break;
    }
}

void main(void)
{
  /* Kelloen nagy tomb a sor beolvasashoz */
  char s[51];
  
  /* Soros vonal "bekapcsolasa" */
  beallitas();
  /*serial_init(9600);*/
  
  /* Klasszikus demo */
  print("Hello World!\n");
  
  /* Kiiras, beolvasas */
  print("Irj be max 50 karaktert: "); gets(s);
  print("Ezt irtad be:\n");
  print(s);
  
  /* Parhuzamos bemenet, valamint a soros vonal egyideju figyelese */
  BE= 1;	/* Bemenet lesz */
  elozo= BE;	/* Mintavetel */
  KI= 0;       	/* Kimenet kezdoerteke */
  for (;;)
    {
      /* Parhuzamos bemenet figyelese */
      if (BE!=elozo)
	/* Megvaltozott bemenet feldolgozasa */
	proc_bemenet();
      /* A soros vonal "nem-blokkolo" vizsgalata */
      if (vetel_volt())
	/* Vetel esemeny feldolgozasa */
	proc_soros();
      /* A foprogram is csinalhat valamit... */
      OUT= !OUT;
    }
}

