/*
 * Support of student board 2012/2013/1
 * CPU: Silabs C8051F020
 */

#ifndef F380_HEADER
#define F380_HEADER

#include "hw.h"
#include "fx.h"


#define NUOF_OSC 6

/* Clock frequencies */
enum t_osc {
  CLK_2M= 4,
  CLK_4M= 5,
  CLK_8M= 6,
  CLK_16M= 7,
  CLK_11M= 0x18,
  CLK_22M= 8
};

/* Baud-rates */
enum t_br {
  BR_0= 0,
  BR_110= 1,
  BR_150= 2,
  BR_300= 3,
  BR_600= 4,
  BR_1K= 5,
  BR_2K= 6,
  BR_4K= 7,
  BR_9K= 8,
  BR_19K= 9,
  BR_38K= 10,
  BR_56K= 11,
  BR_115K= 12
};

struct t_clk_table {
  enum t_osc osc;
  long freq;
};

#define MAGIC_SIGN 0xb0ad1df0

struct t_board_info {
  unsigned long int magic_sign;
  struct t_clk_table clk_table[6];
  enum t_br used_br;
  unsigned char used_clk;
};


extern enum t_br used_br;
extern unsigned char used_clk; // index to clk_table
extern const long
#if defined __C51__
code
#endif
br_table[];
extern const struct t_clk_table
#if defined __C51__
code
#endif
clk_table[NUOF_OSC];

extern unsigned char rst_reason;

extern const struct t_board_info *get_board_info();
extern void silabs_init(enum t_osc osc);
extern void f380_init(void);
extern void br_init(enum t_br br);
extern void oscillator_init(enum t_osc osc);


#if defined __SDCC || defined SDCC
#include "f380_reg.h"
#elif defined __C51__
#else /* IAR4 */
#pragma language=extended
#endif

#if defined __SDCC || defined SDCC
extern void dummy_isr(void) __interrupt(6);
#elif defined __C51__
/*extern void ext0_isr(void);*/
#else /* IAR4 */
/*interrupt void EXT0_int(void);*/
#endif


#endif
