/*
  t0.c
  Segedlet a T0 idozito/szamlalo kezelesehez
  (c) Drotos Daniel, 2005
*/

#include "hw.h"
#include <stdio.h>

#include "timer.h"
#include "t1.h"


/* Idozito uzemmod */

void T1idozito1(bool kapuzott)
{
  TR1= 0;
  TMOD&= 0x0f;
  TMOD|= 0x10;
  if (kapuzott)
    TMOD|= 0x80;
}


/* Szamlalo uzemmod */

void T1szamlalo(bool kapuzott)
{
  TR1= 0;
  TMOD&= 0x0f;
  TMOD|= 0x10;
  TMOD|= 0x40;
  if (kapuzott)
    TMOD|= 0x80;
}


/* Szamlalo ertek beallitasa */

void T1beallit(unsigned int kezdoertek)
{
  TH1= kezdoertek >> 8;
  TL1= kezdoertek & 0xff;
}


/* Szamlalo ertek beallitasa */

void T1ujratolt(unsigned int kezdoertek)
{
  TH1= kezdoertek >> 8;
  TL1= kezdoertek & 0xff;
}


/* A szamlalo aktualis allapota usec-ben */

float T1eltelt_us(void)
{
  unsigned char h, l;
  h= TH1;
  l= TL1;
  return (12.0/Fosc) * ((unsigned int)(h*256+l));
}


/* A szamlalo tulcsordulasaig hatralevo ido usec-ben */

float T1hatravan_us(void)
{
  unsigned char h, l;
  h= TH1;
  l= TL1;
  return (12.0/Fosc) * (0x10000 - (unsigned int)(h*256+l));
}


/* End of t1.c */
